#include "dialogolampara.h"


#include "constantes.h"

#include "dialogolampara.h"

#include "constantes.h"

#include "wx/colordlg.h"

IMPLEMENT_CLASS (DialogoLampara, Dialogo)
DialogoLampara::DialogoLampara()
{
	Init();
}

DialogoLampara::DialogoLampara ( 	wxWindow* ventanaPadre, wxWindowID id,
							const wxString& titulo,
							const wxPoint&  posicion,
							const wxSize&   tam,
							long  			estilo ) 
{
		Init();
		Dialogo::Create (ventanaPadre, id, titulo, posicion, tam, estilo);
}

		
void DialogoLampara::Init()
{
	/*	Aqui se inicializan las variables */
}


void DialogoLampara::ConstruirControles()
{
  
  contenedorCentral = new wxBoxSizer(wxVERTICAL);
  
  contenedorReposo = new wxBoxSizer(wxHORIZONTAL);
  lblVApagado = new wxStaticText(this, ID_STATIC, wxT("Para un voltaje de"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblVApagado, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnVReposo = new wxSpinCtrl(this, ID_VOLTAJE_REPOSO, wxT("0"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, -10, 10, 0);
       
  contenedorReposo->Add(spnVReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblColorInicial = new wxStaticText(this, ID_STATIC, wxT("el color es"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblColorInicial, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  contenedorReposo->Add(10, 10, 0, wxALL, 5);
  lblRReposo = new wxStaticText(this, ID_STATIC, wxT("R:"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblRReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnRReposo = new wxSpinCtrl(this, ID_R_REPOSO, wxT("0"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, 0, 255, 0);
       
  contenedorReposo->Add(spnRReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblGReposo = new wxStaticText(this, ID_STATIC, wxT("G:"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblGReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnGReposo = new wxSpinCtrl(this, ID_G_REPOSO, wxT("0"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, 0, 255, 0);
       
  contenedorReposo->Add(spnGReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblBReposo = new wxStaticText(this, ID_STATIC, wxT("B:"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblBReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnBReposo = new wxSpinCtrl(this, ID_B_REPOSO, wxT("0"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, 0, 255, 0);
       
  contenedorReposo->Add(spnBReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  btnColorReposo = new wxButton(this, ID_COLOR_REPOSO, wxT("Ver/Cambiar color"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(btnColorReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  contenedorCentral->Add(contenedorReposo, 1, wxEXPAND, 5);
  
  contenedorActivacion = new wxBoxSizer(wxHORIZONTAL);
  lblVActivacion = new wxStaticText(this, ID_STATIC, wxT("Para un voltaje de"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorActivacion->Add(lblVActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnVActivacion = new wxSpinCtrl(this, ID_VOLTAJE_ACTIVACION, wxT("5"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, 0, 255, 0);
       
  contenedorActivacion->Add(spnVActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblCActivacion = new wxStaticText(this, ID_STATIC, wxT("el color es"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorActivacion->Add(lblCActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  contenedorActivacion->Add(10, 10, 0, wxALL, 5);
  lblRActivacion = new wxStaticText(this, ID_STATIC, wxT("R:"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorActivacion->Add(lblRActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnRActivacion = new wxSpinCtrl(this, ID_R_ACTIVACION, wxT("255"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, 0, 255, 0);
       
  contenedorActivacion->Add(spnRActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblGActivacion = new wxStaticText(this, ID_STATIC, wxT("G:"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorActivacion->Add(lblGActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnGActivacion = new wxSpinCtrl(this, ID_G_ACTIVACION, wxT("255"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, 0, 255, 0);
       
  contenedorActivacion->Add(spnGActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblBActivacion = new wxStaticText(this, ID_STATIC, wxT("B:"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorActivacion->Add(lblBActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnBActivacion = new wxSpinCtrl(this, ID_B_ACTIVACION, wxT("255"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, 0, 255, 0);
       
  contenedorActivacion->Add(spnBActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  btnColorActivacion = new wxButton(this, ID_COLOR_ACTIVACION, wxT("Ver/Cambiar color"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorActivacion->Add(btnColorActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  contenedorCentral->Add(contenedorActivacion, 1, wxEXPAND, 5);
	
  ConstruirCuadroDeDialogo (contenedorCentral);     
}

/*************************************************/
/* Implementacion de los metodos getter y setter */
/*************************************************/

void DialogoLampara::getPropiedades ( Elemento* elemento )
{
	Lampara* lamp = (Lampara*) elemento;
	TransferirDeNombreDeElementoAControl ( lamp );	
	TransferirDeVoltajeASpin ( spnVReposo,
								lamp->getVoltajeReposo() );
	TransferirDeVoltajeASpin ( spnVActivacion,
								lamp->getVoltajeActivacion() );
	TransferirDeColorASpin	( spnRReposo, spnGReposo, 
					spnBReposo, lamp->getLuminosidadReposo() );
	TransferirDeColorASpin	( spnRActivacion, spnGActivacion, 
					spnBActivacion, lamp->getLuminosidadActivacion() );
	
}

void DialogoLampara::setPropiedades ( Elemento* elemento )
{
	Lampara* lamp = (Lampara*) elemento;
	TransferirDeControlANombreDeElemento ( lamp );	
	
	TransferirDeVoltajeASpin ( spnVReposo,
								lamp->getVoltajeReposo() );
	TransferirDeVoltajeASpin ( spnVActivacion,
								lamp->getVoltajeActivacion() );
	
	TransferirDeSpinAColor	( spnRReposo, spnGReposo, 
					spnBReposo, lamp->getLuminosidadReposo() );
	TransferirDeSpinAColor	( spnRActivacion, spnGActivacion, 
					spnBActivacion, lamp->getLuminosidadActivacion() );
	
}		
/*************************************************/
/*	Fin de implementacion de los getter y setter */		
/*************************************************/

/************************************************/
/*		IMPLEMENTACION DE EVENTOS				*/
/************************************************/


/*	Muestra un cuadro de dialogo de color y mueve la informacion
	del cuadro a los spines. Es un mtodo auxiliar */
void DialogoLampara::ManejarDialogoColor (wxSpinCtrl* r, wxSpinCtrl* g, wxSpinCtrl* b)
{
	
	wxColourData 	datos;
	wxColour		colorConcreto;

	/*	Con NULL se le indica que no queremos colores predefinidos, aunque
		podriamos pasar un vector wxColourData con unos cuantos colores 
	wxColourDialog dialogoColor (this, NULL); */
	
	/*	Queremos elegir todos los posibles colores partiendo del color actual*/
	wxColour color (r->GetValue(), g->GetValue(), b->GetValue() );
	datos.SetChooseFull(true);
	datos.SetColour (color);
	wxColourDialog dialogoColor (this, &datos); 
	dialogoColor.Centre();

	if ( dialogoColor.ShowModal() == wxID_OK )
	{
		datos 			= dialogoColor.GetColourData();
		colorConcreto	= datos.GetColour();
		
		r->SetValue ( colorConcreto.Red()	);
		g->SetValue ( colorConcreto.Green()	);
		b->SetValue ( colorConcreto.Blue()	);
	} 
}

void DialogoLampara::OnColorReposo		(wxCommandEvent& evento)
{
//	wxLogMessage ("Has pulsado el boton para cambiar el color en reposo");
	ManejarDialogoColor ( spnRReposo, spnGReposo, spnBReposo);
}

void DialogoLampara::OnColorActivacion	(wxCommandEvent& evento)
{
//	wxLogMessage ("Has pulsado el boton para cambiar el color en activacion");
	ManejarDialogoColor ( spnRActivacion, spnGActivacion, spnBActivacion);
}

BEGIN_EVENT_TABLE(DialogoLampara, wxDialog)
	EVT_BUTTON (ID_COLOR_REPOSO, 		DialogoLampara::OnColorReposo)
	EVT_BUTTON (ID_COLOR_ACTIVACION, 	DialogoLampara::OnColorActivacion)
END_EVENT_TABLE()

