#ifndef _fabricaelementosvisuales_h
#define _fabricaelementosvisuales_h

#include "elementovisual.h"
#include "../constantes.h"
#include "pulsadorvisual.h"
#include "lamparavisual.h"
#include "electroimanvisual.h"
#include "biestablevisual.h"
#include "relevisual.h"
#include "reedvisual.h"
#include "zumbadorvisual.h"
#include "contadorvisual.h"
#include "temporizadorvisual.h"
#include "fotosensorvisual.h"
#include "sistemavisual.h"
#include "motorvisual.h"
class FabricaDeElementosVisuales
{
	public:
		FabricaDeElementosVisuales();
		/* 	Este mtodo crea una instancia de elemento visual
			a partir de un nmero que indica el tipo de elemento */
		ElementoVisual* CrearElementoVisual(int tipoDeElemento, wxWindow* padre);
		
		/*	Este mtodo tambin crea una instancia pero a partir
			de una cadena como "pulsador" o "lampara"*/
		ElementoVisual* CrearElementoVisual(char* nombre, wxWindow* padre);
	private:
		map<string, int> codigoDeElemento;
		
};

#endif
