#include "relevisual.h"

ReleVisual::ReleVisual()
{	
	/*	El bitmap ya ha sido
		creado en el constructor de la clase padre ElementoVisual,
		por lo que aqui podemos cargarlo sin preocuparnos de reservar */
		
		wxString ficheroIcono ("iconos/Rele.xpm");
		bitmapEnPantalla.LoadFile (ficheroIcono, TIPO_ICONOS);
		
		wxString ficheroIconoInactivo ("iconos/ReleInactivo.xpm");
		bitmapElementoInactivo.LoadFile(ficheroIconoInactivo, TIPO_ICONOS);
		
		wxString ficheroIconoActivo ("iconos/ReleActivo.xpm");
		bitmapElementoActivo.LoadFile(ficheroIconoActivo, TIPO_ICONOS);
		
		bitmapEnPantalla = bitmapElementoInactivo;
		Voltaje* v1		=	new Voltaje(0.0);
		Voltaje* v2		=	new Voltaje(5.0);

		Conexion* c1		= 	new Conexion (false);
		Conexion* c2		=	new Conexion (true);
		elementoEnvuelto = new Rele (v1, c1, v2, c2);
		SetNombre ("Rele");
		senalReposo 	= v1;
		senalActivacion	= v2;
}

void ReleVisual::setElementoEnvuelto (Elemento* e)
{
	wxLogMessage ("---ReleVisual::setElementoEnvuelto---");
	ElementoVisual::setElementoEnvuelto (e);
	Rele* rele = dynamic_cast<Rele*> (e);
	senalReposo 	= rele->getVoltajeReposo();
	senalActivacion = rele->getVoltajeActivacion();
	SetNombre (e->getNombreElemento());
	
}

Dialogo* ReleVisual::FabricarDialogo()
{
	return new DialogoRele();
}

void ReleVisual::ManejarEntrada (Senal* s, int posicion)
{
	wxLogMessage ("Se ha modificado la entrada del rele");
}

