#ifndef _sistemavisual_h
#define _sistemavisual_h

#include "elementovisual.h"
#include "sistema.h"
#include "../dialogos/dialogosistema.h"
#include "../dialogos/dialogoeleccion.h"
class SistemaVisual :public ElementoVisual
{
	public:
		SistemaVisual ();
		~SistemaVisual();
		virtual void setElementoEnvuelto (Elemento* e);
		virtual void manejarEntrada (Senal* s, int posicion=POS_ENTRADA);
		virtual Dialogo* FabricarDialogo();
		
		virtual int		ElegirSalidaDeEmisor();		
		virtual int		ElegirEntradaDeReceptor();	
		
		/*	Permite conocer el nombre de las entradas y salidas, as
			como las posiciones que ocupan. Estos mtodos estaban
			definidos en la clase elemento, raz de la jerarqua.
			
			Se tienen que redefinir aqu para que el sistema visual
			redirija las peticiones al sistema envuelto (almacenado
			en "elementoEnvuelto" */
		virtual map<string,int> getNombreEntradas	();
		virtual map<string,int> getNombreSalidas	();
		
		Sistema* getRefSistema();
};
#endif
