#include "suscripcion.h"

/*	Metodos getter */
Elemento* Suscripcion::getElementoSuscriptor ()
{ 
	return elementoSuscriptor;
}

Elemento* Suscripcion::getElementoAvisador ()	
{
	return elementoAvisador;  
}

int	Suscripcion::getPosEntradaSuscriptor ()	
{ 
	return entradaSuscriptor;  
}

int	Suscripcion::getPosSalidaAvisador	  () 	
{ 
	return salidaAvisador;	 
}


/*	Metodos setter */
int Suscripcion::setElementoSuscriptor (Elemento* e)
{
	if (e==NULL) return -1;
	elementoSuscriptor=e;
	return 0;
}

int  Suscripcion::setElementoAvisador (Elemento *e)
{
	if (e==NULL) return -1;
	elementoAvisador=e;
	return 0;
}

int Suscripcion::setEntradaSuscriptor (int entrada)
{
	if ( (entrada<0) || (entrada>MAX_LONG_VECTOR_ENTRADAS) ) 
		return -1;
	entradaSuscriptor=entrada;
	return 0;
}

int Suscripcion::setSalidaAvisador (int salida)
{
	if ( (salida<0) || (salida>MAX_LONG_VECTOR_SALIDAS) ) 
		return -1;
	salidaAvisador=salida;
	return 0;
}
void Suscripcion::construir (DOMElement*)
{ 
}
