#include "unit++.h"
#include "temporizador.h"
#include "parser.h"

using namespace unitpp;

namespace
{
	
	class PruebaXMLTemporizador : public suite
	{
		void PruebaValoresTemporizador()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			Sistema* sistemaParseado;
			/* 	Se comprueba primero un fichero con un pequeo
				temporizador*/
			ficheroCorrecto	=	p->esValido ("xml\\temporizador.xml");
			if (ficheroCorrecto)
			{
				sistemaParseado=p->getSistema();
				cout << "Sistema XML Temporizador obtenido" << endl;
				/* 	En este punto deberia motor dentro del sistema
					(no modificar los ficheros de test del
					directorio xml) */
				Temporizador* r = (Temporizador*)
					sistemaParseado->getRefElementoPorNombre("Temporizador1");
				cout << "Examinando voltajes" << endl;
				/* Construimos los valores de comparacion a mano...*/	
				Voltaje*  	v1 = new Voltaje  (0.0);
				Voltaje*  	v2 = new Voltaje  (9.0);

				//Valores que leemos y compararemos con los construidos
				//para comprobar si son iguales
				Voltaje*	vInicial;
				Voltaje*	vActivacion;
				Voltaje*	vSalidaInicial;
				Voltaje*	vSalidaTemporizacion;
			}	/* Fin del if que comprueba si el fichero es correcto */
		}
		public:
			PruebaXMLTemporizador() : suite ("Prueba del XML del temporizador")
			{
				add ("PruebaXMLTemporizador", testcase (this,
					"PruebaXMLTemporizador", 
					&PruebaXMLTemporizador::PruebaValoresTemporizador) );
				
				suite::main().add("PruebaXMLTemporizador", this);
			}
	};
	/*	No se descomenta hasta que no est implementado el temporizador*/
	//PruebaXMLTemporizador *p=new PruebaXMLTemporizador();	
}
